//declaring all the global variables needed to be used in the game
//declaring image variable names
var gameOver = new Image(), scene1 = new Image(), scene2 = new Image(), scene3 = new Image(),
avatarR1 = new Image(), avatarR2 = new Image(), avatarL1 = new Image(), avatarL2 = new Image(),
coffeeMeter =  new Image(), heart = new Image(), goodC = new Image(), badC = new Image();
var firstRun = true;

//setting up various variables such as the spawning coordinates and directional factors
var xCoord = 257, yCoord = 249, dir = 'right', walk = false,
room = 1, coffeeLeft = 5, temp, lives = 3, setup = false,
custCoord = 5, custRoom = 2, seatTemp;

//adding image sources to variables names
scene1.src = "img/scene1.jpg"; scene2.src = "img/scene2.jpg"; scene3.src = "img/scene3.jpg";
avatarR1.src = "img/avatarR1.png"; avatarL1.src = "img/avatarL1.png"; avatarR2.src = "img/avatarR2.png"; avatarL2.src = "img/avatarL2.png";
coffeeMeter.src = "img/coffeeMeter.jpg"; heart.src = "img/heartIcon.png"; gameOver.src = "img/gameOver.png"; goodC.src = "img/goodCustomer.png";
badC.src = "img/badCustomer.png";

//final integer variables being setup
var time = 10, customerTime = 17, difficulty = 1, score = 0, custY = 329, coordCheck = 0, custBaseTime = 17;

//game sounds being brought in
var gameOverSound = new Audio("sound/gameOver.mp3");
var pourSound = new Audio("sound/Pour.mp3");

//timer to track time left on each customer, also redraws game each second
var interval = setInterval(function(){customerTime = customerTime - 1; drawCanvas();}, 1000);

//called on canvas load, runs some setup functions such as generating the first customer, the starting the game loop by calling drawCanvas
function setup() {
	customerGenerate();	
	alert("Test");
}

//returns a random number, collapsed to it's own function in case of adding further features that require a random number
function randomInt() {
	var rand = Math.floor(Math.random()*(10-1+1)+1); //10 is max, 1 is min, but these can be changed for variables which are passed when the function is called
	return rand; //returns the random number
}

//creates random number from the randomInt function
function randomIntFromInterval() {
	var i = 0;
	do {
		i = randomInt();
	}
	while(i == custCoord); //keeps relooping until the customer spawns in a different seat, eliminates possibility of customer spawning in the same seat twice
	return i; //returns seat number as i
}

//generates the next customer
function customerGenerate() {
	custCoord = randomIntFromInterval(); //calls the function to randomly allocate a seat
	if(custCoord >= 1 && custCoord <= 5) { //if seat is in first room...
		custRoom = 2; //...sets current room to first room...
	}
	else {
		custRoom = 3; //...otherwise sets it to next room
	}
	custBaseTime = (20 - (difficulty*3)) //sets the time they have left depending on the game difficulty
	customerTime = custBaseTime; //have custBaseTime as it is used in a later calculation, this saves performance as customerTime will be changed and we need custBaseTime to stay the same
}


//main game loop, this is where most of the game logic is stored and the game images are drawn
function drawCanvas() {
	//some local variables that are only used in this function
	var gameCanvas = document.getElementById("gameCanvas"); //shorthand for referring to the canvas, saves code writing
	var textChange = "X = " + xCoord + " Y = " + yCoord; //variable to store the output of players current location
	var ctx = gameCanvas.getContext("2d"); //another shorthand for referring to the game canvas in the context of it being 2 dimensional
	
	document.getElementById('coords').innerHTML = textChange; //outputting player location to debug div
	gameCanvas.height = scene1.height; //refreshing the game canvas height to current background
	gameCanvas.width = scene1.width; //refreshing the game canvas width to current background
	document.getElementById('time').innerHTML = "Time till life lost: " + customerTime; //outputting time left on customer to debug div
	document.getElementById('scoreText').innerHTML = "Score: " + score; //outputting score to debug div
	document.getElementById('custInfo').innerHTML = "Customer Room = " + custRoom + " Customer seat = " + custCoord + " Difficulty: " + difficulty; //outputting misc information to debug div
	
	if(difficulty !=6 && score == difficulty*1000) { //if the difficulty isn't on max and score is 1000 times the difficulty...
		difficulty = difficulty + 1;//...increment the difficulty
	}
	
	if(customerTime == 0) { //if the customer has run out of time
		lives = lives - 1; //take a life away from the player
		customerGenerate(); //generate a new customer by calling function
	}
	
	if(lives !=0) { //if the player has lives left
	
		switch(room) { //tests for which background to draw
			case 1: //starting room
				ctx.drawImage(scene1, 0, 0); //draw scene1 to the canvas
				break;
			case 2: //first room
				ctx.drawImage(scene2, 0, 0); //draw scene2 to the canvas
				if(custRoom == room) { //if the player is in the customers room
					switch(custCoord) { //testing customers seat
						case 1:
							if(customerTime >= custBaseTime/2) { //if the customer has more than half their time left
								ctx.drawImage(goodC, 95, custY); //draw the happy customer
							} else {
								ctx.drawImage(badC, 95, custY); //otherwise draw the unhappy customer
							}
							coordCheck = 5; 						//Code is repeating through the rest of this switch and the next one
							break;									//the next switch tests customer seats in the next room but code is the same
						case 2:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 252, custY);
							} else {
								ctx.drawImage(badC, 252, custY);
							}
							coordCheck = 162;
							break;
						case 3:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 406, custY);
							} else {
								ctx.drawImage(badC, 406, custY);
							}
							coordCheck = 316;
							break;
						case 4:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 590, custY);
							} else {
								ctx.drawImage(badC, 590, custY);
							}
							coordCheck = 500;
							break;
						case 5:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 761, custY);
							} else {
								ctx.drawImage(badC, 761, custY);
							}
							coordCheck = 671;
							break;
						}
				}
				break;
			case 3:
				ctx.drawImage(scene3, 0, 0); //draw the third 
				if(custRoom == room) {
					switch(custCoord) {
						case 6:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 95, custY);
							} else {
								ctx.drawImage(badC, 95, custY);
							}
							coordCheck = 5;
							break;
						case 7:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 252, custY);
							} else {
								ctx.drawImage(badC, 252, custY);
							}
							coordCheck = 162;
							break;
						case 8:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 406, custY);
							} else {
								ctx.drawImage(badC, 406, custY);
							}
							coordCheck = 316;
							break;
						case 9:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 590, custY);
							} else {
								ctx.drawImage(badC, 590, custY);
							}
							coordCheck = 500;
							break;
						case 10:
							if(customerTime >= custBaseTime/2) {
								ctx.drawImage(goodC, 761, custY);
							} else {
								ctx.drawImage(badC, 761, custY);
							}
							coordCheck = 671;
							break;
						}
				}
				break;
			default:
				ctx.drawImage(scene1, 0, 0); //in case any values have been corrupted, draw the starting room. This should never be called but it's just a back up plan
				break;
		} //end of testing background and images to draw
		
		//displaying amount of lives left as hearts
		//using a for loop to save repeated code
		temp = 750; //setting a base value which will be incremented with each loop
		for(var i = 0; i < lives; i++) //for as many lives as the player has
		{
			ctx.drawImage(heart, temp, 495); //draw a heart
			temp = temp + 50; //and then increment the base coordinate
		} //end of for loop
		
		//displaying amount of coffee left with coffeeMeter Image
		//using for loop to save repeated code
		temp = 100; //setting a base coordinate to be incremeneted with the loop
		for(var i = 0; i < coffeeLeft; i++) //for amount of coffee left
		{
			ctx.drawImage(coffeeMeter, temp, 495); //draw image on coordinate variable
			temp = temp + 30; //increment coordinate variable
		} //end of for loop

		//drawing character image based on variables\\
		if(dir == 'right') { //if the character is facing right
			if(walk == true) { //if on right leg
				ctx.drawImage(avatarR1, xCoord, yCoord); //draw character facing right on left leg
				walk = false; //set leg to left
				}
			else { //else if on left leg
				ctx.drawImage(avatarR2, xCoord, yCoord); //draw character facing right on right leg
				walk = true; //set leg to right
				}
			} //end if
		if(dir == 'left') { //if character is facing right
			if(walk == true) { //if on right leg
				ctx.drawImage(avatarL1, xCoord, yCoord); //draw character facing left on left leg
				walk = false; //set leg to left
				}
			else { //otherwise if on left leg
				ctx.drawImage(avatarL2, xCoord, yCoord); //draw character facing left on right leg
				walk = true; //set leg to right
				}
			}
		
		//room change handling
		if(xCoord > 770) { //if on the right boundary
			if(room < 3) //if room isn't furthest right room
			{
				room = room + 1; //increment room
				xCoord = -100; //move character to left side of room
			}
			else //otherwise if on the furthest right room
			{
				xCoord = 770; //block character from moving further forward
			}
		}
		else if(xCoord < -99) { //otherwise if character on left boundary
			if(room > 1) //if room isn't furthest left room
			{
				room = room - 1; //decrease room
				xCoord = 769; //set character position to far right of room
			}
			else //otherwise if room is furthest left room
			{
				xCoord = -100; //block character from moving further left
			}
		}	
		
		gameCanvas.addEventListener('keydown', doKeyDown, true); //adding a listener for any key presses
	} else { //otherwise if the player has no lives left
		clearInterval(interval); //stop game timer
		ctx.fillStyle="#FFFFFF"; //style fill to white
		ctx.fillRect(0, 0, gameCanvas.width, gameCanvas.height); //draw a filled rectangle to clear the screen
		ctx.drawImage(gameOver, 100, 100); // draw the gameover text image
		var audio = document.getElementById("audio"); //linking embedded html song to var audio
		audio.pause(); //stopping game music
		gameOverSound.play(); //playing game over sound
	}
	ctx.font = 'bold 35px Minion Web'; //setting font
	ctx.fillStyle="black"; //setting font colour to black
	ctx.fillText("SCORE: " + score, (gameCanvas.width/2)-70, 525); //drawing the score on bottom of the screen
}

function playerCoordCheck() //function to check if player is on top of a customer
{
	if((xCoord >= (coordCheck - 20) && xCoord <= (coordCheck + 90)) && custRoom == room) //if players coordinates matches customers coordinates with some leeway
	{
		score = score + 100; //increase score by 100
		clearInterval(interval); //clear timer
		interval = setInterval(function(){customerTime = customerTime - 1; drawCanvas();}, 1000); //start new timer
		customerGenerate(); //call function to generate a new customer
		coffeeLeft -= 1; //remove one from coffee counter
		pourSound.play(); //play a pouring sound for feedback
	}
}

function doKeyDown(e){ //if event listener for key pressed is called, run this function

	if(e.keyCode == 68)	{ //testing keycode for key 'D'
		xCoord = xCoord + 15; //increase xCoordinate
		dir = 'right'; //set direction to right
		drawCanvas(); //redraw game 
		} //end if
	
	if(e.keyCode == 65) { //tesing keycode for key 'A'
		xCoord = xCoord - 15; //decrease xCoordinate
		dir = 'left'; //set direction to left
		drawCanvas(); //redraw game
		} //end if
	
	if(e.keyCode == 83) { //testing keycode for key 'S'
			if(coffeeLeft != 0) { //if the character has coffee left
				playerCoordCheck(); //run playercheck function to test if player in on top of a customer
			}
			drawCanvas(); //redraw game
		}
	
	if(e.keyCode == 69) { //testing keycode for key 'E'
		if((xCoord >= 270 && xCoord <= 330) && room == 1) { //testing character room and coordinates for coffee refilling location
			coffeeLeft = 5; //set coffee left back to full (5)
			pourSound.play(); //play the pour sound for feedback
			drawCanvas(); //redraw the game
		}
	}
}